#ifndef COMPARTMENTSTATSACCUMULATOR_H_
#define COMPARTMENTSTATSACCUMULATOR_H_

#include <vector>
using std::vector;
#include <stdint.h>

class CompartmentStatsAccumulator
{
public:
	CompartmentStatsAccumulator();
	CompartmentStatsAccumulator(unsigned int const numberOfReplications, unsigned int const numberOfSpecies);
	~CompartmentStatsAccumulator();

	// Simulated compartment data.
	vector<double>	basalArea;
	vector<double>	meanDiameter;
	vector<double>	meanHeight;
	vector<double>	meanVolume;
	vector<double>	meanVolumePerHectare;
	// Number of trees of each species, each replication
	vector< vector<uint64_t> >	speciesStatistics;
};
#endif /*COMPARTMENTSTATSACCUMULATOR_H_*/
