#include "CompartmentVerifier.h"
#include "CompartmentDataContainer.h"
#include "CompartmentData.h"
#include "Log.h"
#include "Point.h"
#include "Polygon.h"

#include <iostream>
using std::cout;

void CompartmentVerifier::verify(CompartmentDataContainer const & dataContainer) {
	bool error=false;
	size_t const numDatas = dataContainer.size();
	for (size_t i=0; i<numDatas; i++) {
		Polygon const * const poly1 = dataContainer[i]->getCompartmentPolygon();
		for (size_t j=0; j<numDatas; j++) {
			if (i == j)
				continue;

			Polygon const * const poly2 = dataContainer[j]->getCompartmentPolygon();
			vector<Point> const & poly2vertices = *(poly2->getVertices());
			size_t const numberOfVertices = poly2vertices.size();
			for (size_t k=0; k<numberOfVertices; k++) {
				if ( !poly1->hasPoint(poly2vertices[k]) && poly1->fullContains(poly2vertices[k])) {
					cout << "A point (" << poly2vertices[k] << ") from polygon " << j <<" overlaps polygon " << i <<"\n";
					cout << *poly1;
					error=true;
				}
			}
		}
	}
	
	if (error)
		throw "A polygon is overlapping another polygon!";

}
