#ifndef EVALUATORFUNCTIONS_H_
#define EVALUATORFUNCTIONS_H_

class Compartment;
class TreeContainer;

#include <stdint.h>
#include <vector>
using std::vector;
#include <map>
using std::map;

class EvaluatorFunctions {
public:
	static double calculateBasalAreaSum(Compartment const * const compartment);
	static double calculateMarkSum(Compartment const * const compartment, unsigned int const mark);
	static void calculateSpecies(TreeContainer const & trees, vector< map<size_t, uint64_t > > & speciesSums);
	static double calculateMean(double const sum, uint64_t const size);
	static double safeDivision(double const sum, double const divisor);
	static double checkingPow(double const base, double const exponent);
};

#endif /*EVALUATORFUNCTIONS_H_*/
