#include "File.h"
#include "Log.h"
#include <iostream>

vector<string> File::searchPath(1);

File::File(string fileName, ios_base::openmode mode) :
	fstream(fileName.c_str(), mode) {
	Log::log(-1, "Opening file %s", fileName.c_str());

	if (!is_open()) {
		for (unsigned int i = 0; i < searchPath.size(); i++) {
			string fileWithPath;
			fileWithPath.append(searchPath[i]);
			fileWithPath.append("/");
			fileWithPath.append(getFileName(fileName));

			open(fileWithPath.c_str(), mode);

			if (is_open())
				break;
		}
		if (!is_open()) {
			string msg = "Could not open file: ";
			msg.append(fileName);
			throw msg;
		}
		
		// Clear fail bit so read will work
		clear();
	}
}

File::~File() {
	close();
}

string File::getFileName(string filenameWithPath) {
	return getFileNameOrPath(filenameWithPath, 1);
}
string File::getPath(string filenameWithPath) {
	return getFileNameOrPath(filenameWithPath, 0);
}
string File::getFileNameOrPath(string filenameWithPath, int type) {
	int pos = filenameWithPath.rfind('/');
	int lastBackslashPos = filenameWithPath.rfind('\\');
	if (lastBackslashPos > pos)
		pos = lastBackslashPos;

	if (pos == -1)
		return filenameWithPath;
	else if (type == 1)
		return filenameWithPath.substr(pos, filenameWithPath.size()-pos);
	else
		return filenameWithPath.substr(0, pos);

}

void File::addSearchPath(string filenameWithPath) {
	string path = getPath(filenameWithPath);
	searchPath.push_back(path);
}
