#ifndef HELPER_H_
#define HELPER_H_

#include <vector>
using std::vector;
#include <string>
using std::string;
#include <iostream>
using std::cout;
using std::endl;
#include <algorithm>
using std::find;
#include <iterator>
using std::distance;

class Helper {
public:
	inline static void printOut(vector<string> const & names) {
		cout << "Available values are:" << endl;
		size_t const numStrings = names.size();
		for(size_t index=0; index<numStrings; index++) {
			cout << "  \"" << names[index] << "\"" << endl;
		}
	}
	inline static unsigned int getVariableId(string const & name, vector<string> const & variableNames) {
		vector<string>::const_iterator position = find(variableNames.begin(), variableNames.end(), name);
		if (position == variableNames.end()) {
			Helper::printOut(variableNames);
			string temp = "Variable \"" + name + "\" not found, check spelling.";
			throw temp;
		} else {
			return distance(variableNames.begin(), position);
		}
	}
};
#endif /*HELPER_H_*/
