#ifndef LIMITFINDER_H_
#define LIMITFINDER_H_

#include "LimitingModes.h"

class SimulationData;
class TreeContainer;
class Tree;
class CompetitionDistanceModel;

class LimitFinder {

public:
	static LimitFinder& Instance(SimulationData const & sim);
	static LimitFinder& Instance();
	static void Destroy();

	void reset();
	void setLimitingMode(LimitingModes mode);
	inline LimitingModes getLimitingMode() const {
		return currentLimitingMode;
	}
	void update(TreeContainer const & trees);
	inline double getLargestLimitingValue() const {
		return largestNeeded;
	}

protected:
	LimitFinder(SimulationData const & sim);
	~LimitFinder();

private:
	static LimitFinder * singleton;
	void keepTrackOfLargest(Tree const * const curTree, CompetitionDistanceModel& competitionDistanceModel);

	SimulationData const & simulationData;
	double largestDiameter;
	double competitionDistance;
	double largestNeeded;
	LimitingModes currentLimitingMode;
};

#endif /*LIMITFINDER_H_*/
