#ifndef LOG_H_
#define LOG_H_
#include <string>
using std::string;

class Log {
public:
	enum MsgStatus {INFORMATION = 0, WARNING, ERROR, FAILURE, NUMBER_OF_STATUSES};

	static void log(int level, const char *fmt, ...);
	static void logWarning(int level, const char *fmt, ...);
	static void logError(int level, const char *fmt, ...);
	static void logFailure(int level, const char *fmt, ...);

	static void setDirectory(string logDirectory);
	static void finalize();

	static inline unsigned int getMessageCount(MsgStatus status) {
		return msgCounts[status];
	}
private:
	static void logMsg(int level, const char *str);

	static void getElapsed(char* out, double timeInUnits);
	static double getTimestamp();

	static unsigned int msgCounts[NUMBER_OF_STATUSES];
};
#endif /*LOG_H_*/
