#ifdef CATAMOUNT
#include <stdio.h>
#include <catamount/catmalloc.h>
#else
#include <sys/resource.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

#include "Memusage.h"


void Memusage::getMemusage(double *mem) {
#ifdef CATAMOUNT
  size_t fragments;
  unsigned long total_free, largest_free, total_used;
  if (heap_info(&fragments, &total_free, &largest_free, &total_used) == 0) {
        *mem = (double)total_used;
  } else {
	*mem= 0.0;
  }
#else
  FILE *f;
  char str[40];
  unsigned long int pgsz,vmem,rss,shmem,trs,drs,lrs,dt; /* See <man proc> */
  int n;

  *mem = 0.0;
  sprintf(str,"/proc/%d/statm",(int)getpid());
  f = fopen(str,"r");
  if (!f) return;
  n = fscanf(f,"%lu %lu %lu %lu %lu %lu %lu",&vmem,&rss,&shmem,&trs,&drs,&lrs,&dt);
  if (n==7) {
   pgsz = getpagesize();
   *mem = pgsz * rss;
  }
  fclose(f);
#endif

}


