#ifndef PADDEDFIELD_H_
#define PADDEDFIELD_H_

#include <sstream>
using std::stringstream;
#include <iomanip>
using std::setfill;
using std::setw;

/**
 * A fixed sized field which adds padding to the left of the value.
 */
class PaddedField {
public:
	inline PaddedField(unsigned int w, char fill) :
		width(w) {
		ss << setfill(fill);
	}
	inline void setValue(unsigned int value) {
		ss << setw(width) << value;
		ss.seekp(0);
	}
	inline string str() const {
		return ss.str();
	}
private:
	stringstream ss;
	unsigned int width;
};

#endif /*PADDEDFIELD_H_*/
