#ifndef POINTERLESSTHAN_H_
#define POINTERLESSTHAN_H_

#include <functional>
using std::binary_function;

template <class T>
class PointerLessThan : binary_function<T const *, T const *, bool>
{
public:
	inline bool operator()(T const * a, T const * b) {
		// check for NULL
		if (a == NULL) {
			return b != NULL; // if b is also NULL, then they are equal, hence a is not < than b
		} else if (b == NULL) {
			return false;
		} else {
			return *a < *b;
		}
	}
};

#endif /*POINTERLESSTHAN_H_*/
