#include "StumpModel.h"
#include "Tree.h"
#include "SpeciesContainer.h"
#include "Species.h"

double StumpModel::calculateStumpHeightOf(Tree const & tree) {
	double const diameter = tree.getMark(TreeMarks::DIAMETER);
	double const heightInMetres = tree.getMark(TreeMarks::HEIGHT);
	Species const * const species = SpeciesContainer::get(tree.getSpeciesId());
	double const dc = species->get(Species::STUMP_DIAMETER_COEFFICIENT);
	double const hc = species->get(Species::STUMP_HEIGHT_COEFFICIENT);
	double stumpHeight = (dc * diameter + hc * heightInMetres) / 100;
	if (stumpHeight < species->get(Species::STUMP_MIN_HEIGHT)) {
		stumpHeight = species->get(Species::STUMP_MIN_HEIGHT);
	}
	return stumpHeight;
}
