#ifndef TREEMARKS_H_
#define TREEMARKS_H_

#include <string>
using std::string;
#include <vector>
using std::vector;

class TreeMarks {
public:
	/**
	 * Observe that the order of elements in this enumerator specifices the
	 * order in which they will be calculated. Preferably diameter first since
	 * height depends on it.
	 */
	enum Marks { DIAMETER=0, HEIGHT, NUMBER_OF_MARKS };
	
	/**
	 * Returns the name of the mark corresponding to the specified id.
	 */
	static string const & getMarkName(unsigned int id);
	/**
	 * Returns the id of the mark corresponding to the specified name.
	 */
	static unsigned int getMarkId(string const & name);
private:
	static vector<string> setupMarkNames();
	
	static vector<string>	markNames;
};

#endif /*TREEMARKS_H_*/
