/*
 * TreePersistence.h
 *
 *  Created on: 2008-nov-04
 *      Author: joschori
 */
#ifndef TREEPERSISTENCE_H_
#define TREEPERSISTENCE_H_

#include <string>
using std::string;
#include <stdint.h>
#include <vector>
using std::vector;

#ifdef USE_MPI
#include <mpi.h>
#endif

class TreeContainer;

class TreePersistence {
public:
	static void write(TreeContainer const & trees, string const & filename);
	static void read(string const & filename, TreeContainer & trees);
private:
#ifdef USE_MPI
	static uint64_t sumTreesBeforeThisProcess(vector<uint64_t> const & treesInProcesses);
#endif
};

#endif /* TREEPERSISTENCE_H_ */
