#ifndef ASSORTMENTCONTAINER_H_
#define ASSORTMENTCONTAINER_H_

#include <vector>
using std::vector;
#include <string>
using std::string;

#include "Assortment.h"

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

#include <xercesc/util/XercesVersion.hpp>

namespace XERCES_CPP_NAMESPACE
{
	class DOMElement;
}

class AssortmentContainer {
public:
	static void Destroy();

#ifdef USE_MPI
	static void broadcast(int const rootId, MPI_Comm const comm);
#endif
	static void loadData(XERCES_CPP_NAMESPACE::DOMElement const * assortmentData);

	inline static size_t size() {
		return assortments.size();
	}

	static Assortment & get(size_t const index);

	static Assortment & getByName(string const & assortmentName);
private:
	static vector<Assortment> assortments;
};

#endif /* ASSORTMENTCONTAINER_H_ */
