/*
 * ModelFactor.cpp
 *
 *  Created on: 2008-sep-29
 *      Author: joschori
 */

#include "ModelFactor.h"
#include "Model.h"

ModelFactor::ModelFactor(unsigned int const variable, double const expo) :
	exponent(expo), variableId(variable) {

}

ModelFactor::~ModelFactor() {

}

ostream & operator<<(ostream & os, ModelFactor const & fact) {
	if(fact.variableId==Model::INTERCEPT)
		os << 1.0;
	else
		os << Model::getModelVariableName(fact.variableId);
	if(fact.exponent!=1.0)
		os << "^" << fact.exponent;
	return os;
}
