/*
 * ModelFactor.h
 *
 *  Created on: 2008-sep-29
 *      Author: joschori
 */

#ifndef ModelFactor_H_
#define ModelFactor_H_

#include <ostream>
using std::ostream;

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class ModelFactor {
public:
	ModelFactor(unsigned int const variable=0, double const expo=1.0);
	virtual ~ModelFactor();

#ifdef USE_MPI
	inline void broadcast(int const rootId, MPI_Comm const comm) {
		MPIUtil::broadcast(exponent, rootId, comm);
		MPIUtil::broadcast(variableId, rootId, comm);
	}
#endif

	inline double const & getExponent() const {
		return exponent;
	}
	inline unsigned int const & getVariableId() const {
		return variableId;
	}
	friend ostream & operator<<(ostream & os, ModelFactor const & fact);

protected:
	double exponent;
	unsigned int variableId;
};

ostream & operator<<(ostream & os, ModelFactor const & fact);

#endif /* ModelFactor_H_ */
