/*
 * RegenerationModelData.cpp
 *
 *  Created on: 2008-sep-10
 *      Author: joschori
 */
#include "RegenerationModelData.h"
#include "RegenerationModel.h"

RegenerationModelData::RegenerationModelData() :
	coefficients(RegenerationModel::NUMBER_OF_VARIABLES, 0.0) {

}

RegenerationModelData::~RegenerationModelData() {

}

void RegenerationModelData::setCoefficient(unsigned int const index, double const value) {
	if (index < RegenerationModel::NUMBER_OF_VARIABLES)
		coefficients[index] = value;
	else
		throw "Bad coefficients index for RegenerationModelData";
}

void RegenerationModelData::writeModel(ostream & out) const {
	bool firstTerm = true;
	for (unsigned int i = 0; i < RegenerationModel::NUMBER_OF_VARIABLES; i++) {
		if (coefficients[i] != 0.0) {
			if (firstTerm) {
				firstTerm = false;
			} else {
				out << " + ";
			}
			out << coefficients[i] << "*";
			if (i == RegenerationModel::INTERCEPT) {
				out << "1";
			} else {
				out << RegenerationModel::getVariableName(i);
			}
		}
	}
}
