/*
 * RegenerationModelData.h
 *
 *  Created on: 2008-sep-10
 *      Author: joschori
 */

#ifndef REGENERATIONMODELDATA_H_
#define REGENERATIONMODELDATA_H_

#include "Vector.h"
#include <ostream>
using std::ostream;

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class RegenerationModelData {
public:
	RegenerationModelData();
	~RegenerationModelData();

#ifdef USE_MPI
	inline void broadcast(int const rootId, MPI_Comm const comm) {
		MPIUtil::broadcast(coefficients, rootId, comm);
	}
#endif

	inline Vector const & getCoefficients() const {
		return coefficients;
	}
	void setCoefficient(unsigned int const index, double const value);

	void writeModel(ostream & out) const;
private:
	Vector coefficients;
};

#endif /* REGENERATIONMODELDATA_H_ */
