#ifndef DIMENSIONCUTTING_H_
#define DIMENSIONCUTTING_H_

#include "Management.h"

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class Compartment;
class TreeContainer;

class DimensionCutting: public Management {
public:
	DimensionCutting();
	virtual ~DimensionCutting();
	
	virtual MObjectType getObjectType() const { return eDIMENSIONM; }

#ifdef USE_MPI
	virtual void broadcast(int const rootId, MPI_Comm const comm) {
		Management::broadcast(rootId, comm);
		MPIUtil::broadcast(diameterLimit,rootId,comm);
	}
#endif
	virtual void apply(Compartment * compartment, TreeContainer * treeContainer);
	/**
	 * Loads XML data for the Management.
	 * 
	 * Precondition:	@management must not be null.
	 */
	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * management);
	
private:
	double diameterLimit;

};

#endif /*DIMENSIONCUTTING_H_*/
