#ifndef ENERGYWOODCUTTING_H_
#define ENERGYWOODCUTTING_H_

#include "Management.h"

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class Compartment;
class TreeContainer;

class EnergywoodCutting: public Management {
public:
	EnergywoodCutting();
	virtual ~EnergywoodCutting();
	
	virtual MObjectType getObjectType() const { return eENERGYWOODM; }

#ifdef USE_MPI
	virtual void broadcast(int const rootId, MPI_Comm const comm) {
		Management::broadcast(rootId, comm);
		MPIUtil::broadcast(diameterLimit,rootId,comm);
	}
#endif
	virtual void apply(Compartment * compartment, TreeContainer * treeContainer);
	/**
	 * Loads XML data for the Management.
	 * 
	 * Precondition:	@management must not be null.
	 */
	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * management);
	
private:
	double diameterLimit;

};

#endif /*ENERGYWOODCUTTING_H_*/
