#ifndef LINEARTAILWEIBULLFUNCTION_H_
#define LINEARTAILWEIBULLFUNCTION_H_

#include "WeibullFunction.h"
#include <limits>
using std::numeric_limits;

class LinearTailWeibullFunction: public WeibullFunction {
public:
	LinearTailWeibullFunction();
	LinearTailWeibullFunction(double scale, double shape, double origin = 0.0);

	virtual double value(double x) const;

	virtual double derivative(double x) const;

	virtual double upperBound(double tolerance = 0.0001) const;

	virtual void shift(double offset);

	virtual string toString() const;

	void linearizeTail(double classWidth, double ratio);
private:
	double x0;
	double gradient;
	double yIntercept;
};

#endif

