#ifndef NULLMANAGEMENT_H_
#define NULLMANAGEMENT_H_

#include <xercesc/util/XercesVersion.hpp>

#include "Management.h"

/**
 * Implements the Null Object design pattern for Management, i.e. NullManagement's methods doesn't do anything useful,
 * they are only implemented to compile.
 */
class NullManagement : public Management {
public:
	NullManagement();
	virtual ~NullManagement();
	inline virtual MObjectType getObjectType() const {return eNULLM;}
	
	virtual void apply(Compartment * compartment, TreeContainer * treeContainer);
	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * management);
};

#endif /*NULLMANAGEMENT_H_*/
