#ifndef SIZECLASSTHINNING_H_
#define SIZECLASSTHINNING_H_

#include "Management.h"

#include <vector>
using std::vector;

class Tree;
class Compartment;

class SizeClassThinning: public Management {
public:
	virtual ~SizeClassThinning();

protected:
	SizeClassThinning();
	
#ifdef USE_MPI
	virtual void broadcast(int const rootId, MPI_Comm const comm) {
		Management::broadcast(rootId, comm);
		MPIUtil::broadcast(classWidthInCm, rootId, comm);
	}
#endif
	void loadSizeClassData(XERCES_CPP_NAMESPACE::DOMElement const * element);
	
	void setupSizeClassBounds(double minDiameter, double maxDiameter, vector<float> & sizeClassBounds) const;
	void setupSizeClassBounds(Compartment const * const compartment, vector<float> & sizeClassBounds) const;

	void classifyTrees(
		Compartment const * const compartment,
		vector<float> const & sizeClassBounds,
		int sizeClass,
		vector<Tree*> & treesInClass,
		unsigned int & totalNumberOfTreesInClass) const;

	double classWidthInCm;
};
#endif /*SIZECLASSTHINNING_H_*/

