#ifndef TEMPLATECONTAINER_H_
#define TEMPLATECONTAINER_H_

#include <vector>
using std::vector;
#include <string>
using std::string;
#include <cassert>

#ifdef USE_MPI
#include <mpi.h>
#endif

#include <xercesc/util/XercesVersion.hpp>

namespace XERCES_CPP_NAMESPACE {
class DOMElement;
}

class ManagementTemplate;

class TemplateContainer {
public:
	static void Destroy();

#ifdef USE_MPI
	static void broadcast(int const rootId, MPI_Comm const comm);
#endif

	static void add(ManagementTemplate * managementTemplate);
	static ManagementTemplate * get(string const & name);
	static void loadData(XERCES_CPP_NAMESPACE::DOMElement const * templates);
	static unsigned int getId(string const & name);
	inline static ManagementTemplate const * get(unsigned int id) {
		assert(id < managementTemplates.size());
		return managementTemplates[id];
	}
	inline static unsigned int size() {
		return managementTemplates.size();
	}
private:
	static vector<ManagementTemplate*> managementTemplates;

	static ManagementTemplate * silentFind(string const & name);
};

#endif /*TEMPLATECONTAINER_H_*/
