#ifndef WEIBULLFUNCTION_H_
#define WEIBULLFUNCTION_H_

#include <string>
using std::string;

class WeibullFunction {
public:
	WeibullFunction();
	WeibullFunction(double scale, double shape, double origin = 0.0);
	virtual ~WeibullFunction();

	virtual double value(double x) const;

	virtual double maximum() const;

	virtual double derivative(double x) const;

	virtual double upperBound(double tolerance = 0.0001) const;

	virtual void shift(double offset);
	
	inline double scale() const {
		return _scale;
	}
	inline double shape() const {
		return _shape;
	}
	inline double origin() const {
		return _origin;
	}

	virtual string toString() const;
protected:
	double _scale, _shape, _origin;
};

#endif

