#ifndef HOMOGENOUSCLUSTEREDPOINTGENERATOR_H_
#define HOMOGENOUSCLUSTEREDPOINTGENERATOR_H_

#include "ClusteredPointGenerator.h"
#include "HomogenousPoissonPointGenerator.h"

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class HomogenousClusteredPointGenerator : public ClusteredPointGenerator
{
public:
	HomogenousClusteredPointGenerator();
	virtual ~HomogenousClusteredPointGenerator();
	inline virtual PGObjectType getObjectType() const {
		return eHOMOCLUSPG;
	}
#ifdef USE_MPI
	inline virtual void broadcast(int const rootId, MPI_Comm const comm) {
		pointGenerator.broadcast(rootId, comm);
		MPIUtil::broadcast(expectedNumberOfOffspringPoints, rootId, comm);
		MPIUtil::broadcast(offspringDispersionRadius, rootId, comm);
	}
#endif
private:
	virtual PointGenerator const & getPointGenerator() const;
	/**
	 * Loads one XML element.
	 * 
	 * Precondition:	@element must not be null.
	 */
	virtual void loadDatum(XERCES_CPP_NAMESPACE::DOMElement const * element);
	
	HomogenousPoissonPointGenerator	pointGenerator;
};

#endif /*HOMOGENOUSCLUSTEREDPOINTGENERATOR_H_*/
