#ifndef HOMOGENOUSREGULARPOINTGENERATOR_H_
#define HOMOGENOUSREGULARPOINTGENERATOR_H_

#include "RegularPointGenerator.h"

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class HomogenousRegularPointGenerator: public RegularPointGenerator
{
public:
	HomogenousRegularPointGenerator();
	virtual ~HomogenousRegularPointGenerator();
	inline virtual PGObjectType getObjectType() const {
		return eHOMOREGUPG;
	}
#ifdef USE_MPI
	inline virtual void broadcast(int const rootId, MPI_Comm const comm) {
		MPIUtil::broadcast(density, rootId, comm);
		MPIUtil::broadcast(interactionRadius, rootId, comm);
		homogenousPoissonPointGenerator.broadcast(rootId,comm);
	}
#endif
private:
	virtual double calculatePointPotential(vector<Point> const & points) const;
	/**
	 * Loads one XML element.
	 * 
	 * Precondition:	@element must not be null.
	 */
	virtual void loadDatum(XERCES_CPP_NAMESPACE::DOMElement const * element);
};

#endif /*HOMOGENOUSREGULARPOINTGENERATOR_H_*/
