#ifndef INHOMOGENOUSCLUSTEREDPOINTGENERATOR_H_
#define INHOMOGENOUSCLUSTEREDPOINTGENERATOR_H_

#include "ClusteredPointGenerator.h"
#include "InhomogenousPoissonPointGenerator.h"

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

class Vector;

class InhomogenousClusteredPointGenerator : public ClusteredPointGenerator
{
public:
	InhomogenousClusteredPointGenerator();
	virtual ~InhomogenousClusteredPointGenerator();
	inline virtual PGObjectType getObjectType() const {
		return eINHOCLUSPG;
	}
#ifdef USE_MPI
	inline virtual void broadcast(int const rootId, MPI_Comm const comm) {
		pointGenerator.broadcast(rootId, comm);
		MPIUtil::broadcast(expectedNumberOfOffspringPoints, rootId, comm);
		MPIUtil::broadcast(offspringDispersionRadius, rootId, comm);
	}
#endif
private:
	virtual PointGenerator const & getPointGenerator() const;
	/**
	 * Loads one XML element.
	 * 
	 * Precondition:	@element must not be null.
	 */
	virtual void loadDatum(XERCES_CPP_NAMESPACE::DOMElement const * element);
	
	InhomogenousPoissonPointGenerator	pointGenerator;
};

#endif /*INHOMOGENOUSCLUSTEREDPOINTGENERATOR_H_*/
