#ifndef NULLPOINTGENERATOR_H_
#define NULLPOINTGENERATOR_H_

#include "PointGenerator.h"

/**
 * Implements the Null Object design pattern for PointGenerator, i.e. NullPointGenerator's methods doesn't do anything useful,
 * they are only implemented to compile.
 */
class NullPointGenerator: public PointGenerator
{
public:
	NullPointGenerator();
	virtual ~NullPointGenerator();
	inline virtual PGObjectType getObjectType() const {
		return eNULLPG;
	}
#ifdef USE_MPI
	inline virtual void broadcast(int const rootId, MPI_Comm const comm) {
		// nothing to see here, move along.
	}
#endif
	virtual void generatePointsInside(Polygon const & shape, double const percent, vector<Point> & points) const;
	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * pointGenerator);
};

#endif /*NULLPOINTGENERATOR_H_*/
