#ifndef STANDARDNORMALRANDOMNUMBERGENERATOR_H_
#define STANDARDNORMALRANDOMNUMBERGENERATOR_H_

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

#include <cmath>
using std::abs;

class StandardNormalRandomNumberGenerator
{
public:
	StandardNormalRandomNumberGenerator();
	virtual ~StandardNormalRandomNumberGenerator();
	static double get();
	static double getLimited();
	inline static void setLimitingFactor(double lim) {
		limitingFactor = std::abs(lim);
	}
	inline static double getLimitingFactor() {
		return limitingFactor;
	}
#ifdef USE_MPI
	static void broadcast(int const rootId, MPI_Comm const comm);
#endif
private:
	static double limitingFactor;
	static double v2;
	static double epsilon;
	static int init;
};

#endif /*STANDARDNORMALRANDOMNUMBERGENERATOR_H_*/
