#ifndef UNIFORMRANDOMNUMBERGENERATOR_H_
#define UNIFORMRANDOMNUMBERGENERATOR_H_

#ifdef USE_MPI
#include "MPIUtil.h"
#endif

#include "RandomNumberGenerator.h"

class Tree;

class UniformRandomNumberGenerator : public RandomNumberGenerator {
public:
	UniformRandomNumberGenerator();
	~UniformRandomNumberGenerator();
	virtual double get();
	inline static double getSeed() {
		return newSeed;
	}
#ifdef USE_MPI
	static void broadcast(int const rootId, MPI_Comm const comm);
#endif

private:
	friend class Simulation;
	friend class SimulationData;
#ifdef COMPARISONSEEDING
	friend class SelectiveThinning;
	friend class Forest;
	friend class InitialCompartmentGenerator;
	friend class Compartment;
	friend class ClearCut;
	friend class LowThinning;
	friend class ForestInitializer;
	friend class Model;
	friend class TreeContainer;
#endif
	inline static void storeSeed(double const seed) {
		newSeed=seed;
	}
	static void setSeed(double const newSeed);

#ifdef COMPARISONSEEDING
static void setSeeds(Tree const * const t, double const value);
#endif

	static double newSeed;
};

#endif /*UNIFORMRANDOMNUMBERGENERATOR_H_*/
