#ifndef FORESTTYPECONTAINER_H_
#define FORESTTYPECONTAINER_H_

#include <vector>
using std::vector;
#include <string>
using std::string;

#ifdef USE_MPI
#include <mpi.h>
#endif

#include <xercesc/util/XercesVersion.hpp>

namespace XERCES_CPP_NAMESPACE {
	class DOMElement;
}

class ForestType;

class ForestTypeContainer {
public:
	static void Destroy();

#ifdef USE_MPI
	static void broadcast(int const rootId, MPI_Comm const comm);
#endif

	static inline size_t size() {
		return typeList.size();
	}
	static ForestType * get(size_t const id);
	static void add(ForestType * const type);
	static unsigned int getId(string const & name);
	static void loadData(XERCES_CPP_NAMESPACE::DOMElement const * types);

private:
	static vector<ForestType*> typeList;

};
#endif /*FORESTTYPECONTAINER_H_*/
