#ifndef FORESTTYPEDATA_H_
#define FORESTTYPEDATA_H_

#include <string>
using std::string;

#ifdef USE_MPI
#include <mpi.h>
#endif

class ForestTypeData {
public:
	ForestTypeData();
	~ForestTypeData();
#ifdef USE_MPI
	void broadcast(int const rootId, MPI_Comm const comm);
#endif
	inline double getSpeciesAmount() const { return speciesAmount; }
	inline string const & getSpeciesName() const { return speciesName; }
	inline double getSpeciesReproductionAmount() const {
		if (speciesReproductionAmount < 0.0) {
			// speciesReproductionAmount is not defined
			return speciesAmount;
		} else {
			return speciesReproductionAmount;
		}
	}
	inline double getSpeciesInitialDiameterFactor() const { return speciesInitialDiameterFactor; }
	inline double getSpeciesNewDiameterFactor() const { return speciesNewDiameterFactor; }
	inline void setSpeciesAmount(double amount) { speciesAmount = amount; }
	inline void setSpeciesName(string const & name) { speciesName = name; }
	inline void setSpeciesReproductionAmount(double amount) { speciesReproductionAmount = amount; }
	inline void setSpeciesInitialDiameterFactor(double initialDiameterFactor) { speciesInitialDiameterFactor = initialDiameterFactor; }
	inline void setSpeciesNewDiameterFactor(double newDiameterFactor) { speciesNewDiameterFactor = newDiameterFactor; }

private:
	string speciesName;
	double speciesAmount;
	double speciesReproductionAmount;
	double speciesInitialDiameterFactor;
	double speciesNewDiameterFactor;
};


#endif /*FORESTTYPEDATA_H_*/
