#ifndef MARKDATADISTRIBUTION_H_
#define MARKDATADISTRIBUTION_H_

#include "MarkDistribution.h"

#include <string>
using std::string;

/**
 * Loads empirical data from a file and generates an ECDF therefrom.
 */
class MarkDataDistribution : public MarkDistribution {
public:
	MarkDataDistribution();
	MarkDataDistribution(string const & filename);

	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * distribution);
	virtual void setUp(vector<double> & classes, vector<double> & values);
private:
	void loadEmpiricalData(vector<double> & points) const;

	void findMinimumAndMaximumMarks(vector<double> const & points, double & lower, double & upper) const;

	void setupClasses(double lower, double upper, vector<double> & classBounds) const;

	void classifyData(vector<double> const & points, vector<double> const & classBounds,
			vector<unsigned int> & frequencies) const;

	string filename;
};

#endif

