#include "MarkECDFDistribution.h"

#include "File.h"

#include "XercesString.h"
#include "XercesUtilities.h"
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOMElement.hpp>
XERCES_CPP_NAMESPACE_USE

#include <iostream>
using std::ios_base;

MarkECDFDistribution::MarkECDFDistribution() {
}

MarkECDFDistribution::MarkECDFDistribution(string const & filename) :
	filename(filename) {
}

void MarkECDFDistribution::loadData(XERCES_CPP_NAMESPACE::DOMElement const * distribution) {
	filename = XercesUtilities::getFirstChildTextContentAsString(distribution);
}

void MarkECDFDistribution::setUp(vector<double> & classes, vector<double> & values) {
	File in(filename, ios_base::in);
	double x, y;
	while (in.good()) {
		in >> x;
		if (!in.good()) break;
		in.ignore(1);
		in >> y;
		if (!in.good()) break;
		classes.push_back(x);
		values.push_back(y);
	}
}

