#ifndef MARKECDFDISTRIBUTION_H_
#define MARKECDFDISTRIBUTION_H_

#include "MarkDistribution.h"

#include <string>
using std::string;

/**
 * Reads an empirical CDF from a file. The provider of the file is responsible
 * for the ECDF being well-formed.
 */
class MarkECDFDistribution : public MarkDistribution {
public:
	MarkECDFDistribution();
	MarkECDFDistribution(string const & filename);

	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * distribution);
	virtual void setUp(vector<double> & classes, vector<double> & values);
private:
	string filename;
};

#endif

