#ifndef MARKNORMALDISTRIBUTION_H_
#define MARKNORMALDISTRIBUTION_H_

#include "MarkDistribution.h"

/**
 * Generates a CDF for a positive normal distribution. The distribution will be
 * truncated to encompass three times the standard deviation in each direction
 * from the mean. It will however never span negative values. If need be, it is
 * furthermore symmetrically truncated not to span negative values. 
 */
class MarkNormalDistribution : public MarkDistribution {
public:
	MarkNormalDistribution();
	MarkNormalDistribution(double mean, double stddev);

	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * distribution);
	virtual void setUp(vector<double> & classes, vector<double> & values);
private:
	double mean;
	double stddev;
};

#endif

