#ifndef MARKWEIBULLDISTRIBUTION_H_
#define MARKWEIBULLDISTRIBUTION_H_

#include "MarkDistribution.h"

/**
 * Generates a CDF for a Weibull distribution. The distribution can be offset
 * to start at an x value larger than zero.
 */
class MarkWeibullDistribution : public MarkDistribution {
public:
	MarkWeibullDistribution();
	MarkWeibullDistribution(double scale, double shape, double origin = 0);

	virtual void loadData(XERCES_CPP_NAMESPACE::DOMElement const * distribution);
	virtual void setUp(vector<double> & classes, vector<double> & values);
private:
	double origin;
	double scale;
	double shape;
};

#endif

