#include "XercesErrorHandler.h"
#include "XercesString.h"

#include <xercesc/sax/SAXParseException.hpp>
XERCES_CPP_NAMESPACE_USE

#include <iostream>
using std::cerr;

XercesErrorHandler::XercesErrorHandler()
{
}

XercesErrorHandler::~XercesErrorHandler()
{
}

void XercesErrorHandler::warning(SAXParseException const & e)
{
	XercesString msg = XMLString::replicate(e.getMessage());
	cerr << "Warning: " << msg.toString() << " in XML file at line ";
	cerr << e.getLineNumber() << " column " << e.getColumnNumber() << "\n";
}

void XercesErrorHandler::error(SAXParseException const & e)
{
	fatalError(e);
}

void XercesErrorHandler::fatalError(SAXParseException const & e)
{
	XercesString msg = XMLString::replicate(e.getMessage());
	cerr << "Syntax error in XML file at line ";
	cerr << e.getLineNumber() << " column " << e.getColumnNumber() << "\n";
	cerr << "Message: " << msg.toString() << "\n";
	throw "Could not parse XML file";
}

void XercesErrorHandler::resetErrors()
{
	// TODO
}
