#ifndef XERCESERRORHANDLER_H_
#define XERCESERRORHANDLER_H_

#include <xercesc/sax/ErrorHandler.hpp>
#include <xercesc/util/XercesVersion.hpp>

namespace XERCES_CPP_NAMESPACE
{
	class SAXParseException;
}

/**
 * Basic error handler that simply rethrows the messages in the SAXParseExceptions
 * as standard strings.
 */
class XercesErrorHandler: public XERCES_CPP_NAMESPACE::ErrorHandler
{
public:
	XercesErrorHandler();
	virtual ~XercesErrorHandler();
	
	virtual void warning(XERCES_CPP_NAMESPACE::SAXParseException const & e);
	virtual void error(XERCES_CPP_NAMESPACE::SAXParseException const & e);
	virtual void fatalError(XERCES_CPP_NAMESPACE::SAXParseException const & e);
	virtual void resetErrors();
};

#endif /*XERCESERRORHANDLER_H_*/
