#include "XercesString.h"

#include <xercesc/util/XMLString.hpp>
XERCES_CPP_NAMESPACE_USE

#include <sstream>
using std::stringstream;

XercesString::XercesString(XMLCh * strr)
: str(strr)
{
}

XercesString::~XercesString()
{
	XMLString::release(&str);
}

XercesString::XercesString(XercesString const & toCopy)
: str(0)
{
	*this = toCopy;
}

XercesString & XercesString::operator=(XercesString const & rhs)
{
	// Handles self-assignment implicitly.
	XMLCh * temp = XMLString::replicate(rhs.str);
	XMLString::release(&str);
	str = temp;
	return *this;
}

XMLCh const * XercesString::xmlCh() const
{
	return str;
}

int XercesString::toInt() const
{
	stringstream temp(toString());
	int i=0;
	temp >> i;
	return i;
}

double XercesString::toDouble() const
{
	stringstream temp(toString());
	double d=0.0;
	temp >> d;
	return d;
}

string XercesString::toString() const
{
	char * tempChars = XMLString::transcode(str); 
	string tempString(tempChars);
	XMLString::release(&tempChars);
	return tempString;
}
