#ifndef XERCESSTRING_H_
#define XERCESSTRING_H_

#include <string>
using std::string;

#include <xercesc/util/XMLUniDefs.hpp>

/**
 * Convenience class for handling Xerces' XMLCh character format.
 * Provides conversion from XMLCh to int, double and string.
 */
class XercesString
{
public:
	XercesString(XMLCh * strr = 0);
	~XercesString();
	
	XercesString(XercesString const & toCopy);
	XercesString & operator=(XercesString const & rhs);
	
	XMLCh const * xmlCh() const;
	int toInt() const;
	double toDouble() const;
	string toString() const;
private:
	XMLCh *	str;
};

#endif /*XERCESSTRING_H_*/
